VERSION 5.00
Begin VB.UserControl EzRadio 
   ClientHeight    =   315
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3675
   ScaleHeight     =   21
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   245
End
Attribute VB_Name = "EzRadio"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'This is a simple radio button.
'Created by: Aceng Suparman
'Date Created: 31/03/2004
'Email: belehem@msn.com; aceng_suparman2001@yahoo.com


Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Public Enum enRadio
    enRadioOff = 0
    enRadioOn = 1
End Enum
Public Enum enAlignment
    enLeft = 0
    enRight = 1
End Enum
'Default Property Values:
Const m_def_Alignment = enLeft
Const m_def_value = enRadioOff
Const m_def_Caption = "0"
'Property Variables:
Dim m_Alignment As Byte
Dim m_value As enRadio
Dim m_Caption As String

'Event Declarations:
Event Changed()
'

Private Sub UserControl_Click()
   Dim ob As Object
   For Each ob In UserControl.ParentControls
        If TypeOf [ob] Is EzRadio Then
             If GetParent(ob.hWnd) = GetParent(Me.hWnd) Then
                ob.value = enRadioOff
            End If
        End If
   Next
   Me.value = enRadioOn
End Sub


'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_value = m_def_value
    m_Caption = UserControl.Ambient.DisplayName
    m_Alignment = m_def_Alignment
End Sub
Private Sub UserControl_Paint()
    drawRadio
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_value = PropBag.ReadProperty("value", m_def_value)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    m_Alignment = PropBag.ReadProperty("Alignment", m_def_Alignment)
End Sub

Private Sub UserControl_Resize()
    UserControl.Height = 315
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("value", m_value, m_def_value)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("Alignment", m_Alignment, m_def_Alignment)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get value() As enRadio
    value = m_value
End Property

Public Property Let value(ByVal New_value As enRadio)
    m_value = New_value
    PropertyChanged "value"
    drawRadio
    RaiseEvent Changed
End Property
'
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,0
Public Property Get Caption() As String
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"
    drawRadio
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get Alignment() As enAlignment
    Alignment = m_Alignment
End Property

Public Property Let Alignment(ByVal New_Alignment As enAlignment)
    m_Alignment = New_Alignment
    PropertyChanged "Alignment"
    drawRadio
End Property
Private Function drawRadio()
    Dim nLeftPos As Single, TopLeftColor As OLE_COLOR, BottomRightColor As OLE_COLOR
    If Me.Alignment = enLeft Then
        nLeftPos = 2.5
    Else
        nLeftPos = UserControl.ScaleWidth - UserControl.ScaleHeight + 2.5
    End If
    If m_value = enRadioOff Then
        TopLeftColor = vbHighlightText
        BottomRightColor = vbButtonShadow
    Else
        TopLeftColor = vbButtonShadow
        BottomRightColor = vbHighlightText
    End If
    With UserControl
        .Cls
        .ForeColor = TopLeftColor
        Line (nLeftPos, 2.5)-(nLeftPos + .ScaleHeight - 5, 2.5)
        Line (nLeftPos, 2.5)-(nLeftPos, .ScaleHeight - 2.5)
        .ForeColor = BottomRightColor
        Line (nLeftPos, .ScaleHeight - 2.5)-(nLeftPos + .ScaleHeight - 5, .ScaleHeight - 2.5)
        Line (nLeftPos + .ScaleHeight - 5, 2.5)-(nLeftPos + .ScaleHeight - 5, .ScaleHeight - 2.5)
        
        .ForeColor = vbBlack
        If Me.Alignment = enLeft Then
            .CurrentX = nLeftPos + .ScaleHeight
        Else
            .CurrentX = nLeftPos - .TextWidth(Me.Caption) - 2.5
        End If
        .CurrentY = .ScaleHeight / 2 - .TextHeight(Me.Caption) / 2
        Print Me.Caption
    End With
    
End Function
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
    hWnd = UserControl.hWnd
End Property

